﻿// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>
#include <ctime>

#pragma comment(lib, "winmm.lib")

__int64 GetQPCTime()
{
    LARGE_INTEGER qpcTime;
    QueryPerformanceCounter(&qpcTime);

    __int64 t = __rdtsc();

    return qpcTime.QuadPart;
}

__int64 GetQPCFreq()
{
    LARGE_INTEGER qpcRate;
    QueryPerformanceFrequency(&qpcRate);
    return qpcRate.QuadPart;
}

int main()
{
    timeBeginPeriod(1);

    const DWORD msDuration = 1000;
    const int iterations = 6;
    const __int64 qpcFreqency = GetQPCFreq();

    for (int i = 0; i < iterations; ++i)
    {
        __int64 qpcStart = GetQPCTime();
        
        DWORD startTick = timeGetTime();
        for (;;)
        {
            DWORD tickDuration = timeGetTime() - startTick;
            if (tickDuration >= msDuration)
            {
                break;
            }
        }

        __int64 qpcElapsed = GetQPCTime() - qpcStart;
        printf("%I64d / %I64d == %0.4f\n", qpcElapsed, qpcFreqency, ((double)qpcElapsed / qpcFreqency));
    }

    timeEndPeriod(1);

    return 0;
}

